using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;
using UnityEngine.Windows.Speech;

using SimpleJSON;

using MVR.FileManagementSecure;

namespace Amaimon {

    // reload: onDisable -> onDestroy -> onEnable -> Init
    // disable: OnDisable
    // enable: OnEnable
    // wczytanie w nowej scenie: onEnable -> Init

    // OnEnable -> [Init] -> OnDisable -> OnD-estroy

    public class StoryPlugin : MVRScript
    {
        // JSONStorableString _debug;		
        // protected JSONStorableFloat _slider1;
        // protected JSONStorableFloat _slider2;
        // protected JSONStorableFloat _slider3;
        // protected JSONStorableFloat _slider4;

        // UIDynamicTextField _debugTextField;

        private int sceneIterator = 0;
        private Scene scene = null;

        public bool firstPerson = false;

        // ======== fader
        private GameObject myWindowCamera;
		private GameObject myMonitorRig;
		private Mesh myMesh;
		private Material myMaterial;
		private Color myColor = Color.black;
		private float myFadeClock = 0.0f;
		private bool myActive = false;
		private float myTime = 5;
        // ======== fader

        private static StoryPlugin _instance = null;
        public static StoryPlugin singleton
        {
            get
            {
                return _instance;
            }
        }

        AActor male = null;
        AActor female = null;

        // public static List<AActor> actors;
        // public static List<AAtom> objects;
        public static List<AAtom> storyObjects = new List<AAtom>();

        ///////////////////////////////////////////////////
        // Update()
        // Run things every frame
        ///////////////////////////////////////////////////

        public void Update()
        {
            Player.singleton.Update();

            // var cc = Player.singleton.playerHead.gameObject.GetComponentInChildren<Rigidbody>().transform.position;
            // var dist = female.getUniversalRigidbody("head").transform.position;

            // Log.d($"Ph:{Vector3.Distance(cc,dist)}");

            //Log.d($"chest: {dist.magnitude}");


            Scene nextScene = scene?.onEachFrame();

            if(nextScene != null) {
                changeScene(nextScene);
            }
            else if (Input.GetKeyDown("6"))
            {
                female.rhytmTrackder.click();
                //Log.d($"Female received {female.rhytmTrackder.get()}");
            }
            else if (Input.GetKeyDown("8"))
            {
                Log.d("8 key was pressed");
                togglePov();
            }
            else if (Input.GetKeyDown("9"))
            {
                Log.d("9 key was pressed");

                // if(sceneIterator > 2)
                //     sceneIterator = 0;
                // Scene newScene = null;

                // if(sceneIterator == 0) {
                //     newScene = MiscScenes.getBlowjobScene(male, female);
                // }
                // else if(sceneIterator == 1) {
                //     newScene = MiscScenes.getAnalSpooning(male, female);
                // }
                // else if(sceneIterator == 2) {
                //     newScene = MiscScenes.getCockRiding(male, female);
                // }
        
                // Log.d($"changing scene to:{newScene}");

                // changeScene(newScene);

                // sceneIterator++;
            }
        }

        ///////////////////////////////////////////////////
        // FixedUpdate()
        // Run things every physics tick
        ///////////////////////////////////////////////////
        public void FixedUpdate()
        {
            // EVERY PHYSICS TICK
            Player.singleton.FixedUpdate();
            scene?.onPhysicsTick();
        }

 
         ///////////////////////////////////////////////////
        // OnEnable()
        // When plugin enabled
        ///////////////////////////////////////////////////
        public void OnEnable()
        {
            try
            {
                _instance = this; // because onEnable is called before Init!
            }
            catch (Exception e)
            {
                SuperController.LogError($"{nameof(StoryPlugin)}.{nameof(OnEnable)}: {e}");
            }
        }


        ///////////////////////////////////////////////////
        // LateUpate()
        // Chuj wi co
        ///////////////////////////////////////////////////

		private void LateUpdate()
		{
            // Fader code			
			float delta = myActive ? Time.deltaTime: -Time.deltaTime;
			delta /= Mathf.Max(myTime, 0.001f);
			myFadeClock = Mathf.Clamp01(myFadeClock+delta);
			if (myFadeClock > 0.0f)
			{
				myColor.a = Mathf.SmoothStep(0.0f, 1.0f, myFadeClock);
				myMaterial.color = myColor;			
				
				bool usingWindowCamera = myWindowCamera != null && myWindowCamera.activeSelf &&	!myMonitorRig.activeSelf;
				Transform transform = usingWindowCamera ? myWindowCamera.transform : CameraTarget.centerTarget.transform;
				Graphics.DrawMesh(myMesh, transform.localToWorldMatrix, myMaterial, gameObject.layer, null, 0, null, castShadows: false, receiveShadows: false);
			}
		}

        ///////////////////////////////////////////////////
        // Init()
        // Run once, when plugin loaded
        ///////////////////////////////////////////////////
        public override void Init()
        {
            // called only once!
            // here GUI buttons migt be set up
            try {
                GameObject prefab = GameObject.CreatePrimitive(PrimitiveType.Cube);
                myMesh = prefab.GetComponent<MeshFilter>().mesh;
                DestroyImmediate(prefab);
                
                Shader[] shaders = Resources.FindObjectsOfTypeAll<Shader>();
                Shader shader = Array.Find(shaders, s => s.name == "Custom/TransparentHUD");
                myMaterial = new Material(shader);
                myMaterial.renderQueue = 10000;
                
                Atom windowCameraAtom = GetSceneAtoms().Find(a => a.type == "WindowCamera");
                CameraControl windowCamera = windowCameraAtom?.GetStorableByID("CameraControl") as CameraControl;
                myWindowCamera = windowCamera?.cameraGroup.gameObject;
                
                myMonitorRig = SuperController.singleton.MonitorRig.gameObject;

            }
            catch (Exception e)
            {
                SuperController.LogError($"Problem with fader {nameof(StoryPlugin)}.{nameof(Init)}: {e}");
            }

            try
            {
                var info = @"<size=50><b>Some info</b></size>
This plugin was not designed for end user, nevertheless the settings on the left may be used to test its various features available to people who can code. Note that it is still a work in progress, so many features are wonky or badly tuned.
It doesn't matter where you put this plugin, it will manage and track <b>ALL</b> persons available in this scene.
<b>Manage hands</b> - make this person touch persons selected below, note that she/he won't botter with touching anything that is too far away, so to get intimate place your actors CLOSE to each other. Basic implementation of right hand when facing another person - for now.
<b>person -> YYY touch</b> - tick to enable this person touch person YYY
<b>Manage eyes</b> - make this person look at persons selected below, current setting will give more attention to parts of the body that are close or move fast. Also to allow you testing glances at inanimate objects, you may rename them to start with _story_, and reapply the settings.
<b>Manage head</b> - head will also follow interests selected below.
<b>person -> YYY glance</b> - tick to enable this person look at person YYY
<b>Manage mood</b> - apply expressions based on this person's mood (more about it later).
<b>Apply above settings</b>  - press to commit after you tick/untick anything in options above.
<b>Sexdoll mode</b>  - press to put this person into sexdoll-like state. This mode also supports pushing the person off balance, so if your model is standing, try pushing him/her into a bed!
<b>Managing mood</b> and <b>arousal</b> - For now it is primitive - touch gently or caress to increase arousal (notice how whole body reacts to your touch) or try spanking, but it's still a very fresh feature. Note that if you spank your model in ragdoll mode, you probably knock him/her out!
<b>Enable embody</b> if your scene female has embody plugin appled, pressing key <b>8</b> will enable it.
Notes:
- Both vagina and throat support bulge, vagina and anus react to penetration speed and direction, but penetration is not yet implemented.
- The best experience is of course using posession or Embody, but without it there's a fake <b>Player</b> actor in the scene that has physical head, chest and abdomen (fails on first load of the plugin, reload to enable this feature!).
- VR hand finger configuration may be changed by pressing your controller action key.

";
                MacGruber.Utils.SetupInfoText(this, info, 2000, true);
            } catch (Exception e)
            {
                SuperController.LogError($"Problem in UI setup {nameof(StoryPlugin)}.{nameof(Init)}: {e}");
            }
            


/*
You need to create a JSONStorableAction where the callback performs the action you want. 
Then use RegisterAction on the MVRScript passing the JSONStorableAction. 
That will make the action accessible to the standard VAM trigger system.
*/

		    var action = MacGruber.Utils.SetupAction(this, "Toggle embody", togglePov);

            try {
                storyObjects.ForEach(ob => {
                    ob.cleanup();
                });
            } catch (Exception ex) {
                Log.d("Problem destroying old objects!");
            }

            myTime = 0.1f;
            myActive = true;

            storyObjects.Clear();

            StartCoroutine(

            doWhenLoaded(()=>{




                var aactors = findPersonAtoms().Select<Atom, AActor>(whom => {
                    if(whom.GetComponentInChildren<DAZCharacterSelector>().gender.ToString() == "Male")
                        return (new MaleActor(whom));
                    else
                        return (new FemaleActor(whom));
                }).ToList();

                aactors.ForEach(it => {
                    storyObjects.Add(it);
                    it.setup();
                });

                aactors.ForEach(it => {
                    it.addPanel(this);
                });

                Player.singleton.setup();

                findObjectsAtomsWithName("_story_").Select(what => new AAtom(what)).ForEach(it => storyObjects.Add(it));

                try {
                    male = (AActor)storyObjects.First(whom => whom is AActor && ((AActor)whom).isMale());
                } catch (Exception ex) {
                    male = null;
                }

                try {
                    female = (AActor)storyObjects.First(whom => whom is AActor && !((AActor)whom).isMale());
                } catch (Exception ex) {
                    female = null;
                }

                //female.listClothes();

                var newScene = new DefaultScene(male, female);
                newScene.state = new DefaultState(male, female, newScene.root);

                // var newScene = new LeavingForPartyScene(male, female);
                // newScene.state = new PosingState(male, female, newScene.root);

                changeScene(newScene);            






            }));
        }

        ///////////////////////////////////////////////////
        // OnDisable()
        // Run things when plugin disabled
        ///////////////////////////////////////////////////
        public void OnDisable()
        {
            try
            {
                scene?.onExit();
                Player.singleton.isListeningForDictionary = false;
                Player.singleton.stopSentenceRecognizer();
            }
            catch (Exception e)
            {
                SuperController.LogError($"{nameof(StoryPlugin)}.{nameof(OnDisable)}: {e}");
            }
        }

        ///////////////////////////////////////////////////
        // OnDestroy()
        // Run when plugin removed
        ///////////////////////////////////////////////////
        public void OnDestroy()
        {
            StoryPlugin.ferEachActor(whom => {
                whom.arousalMorph.reset();
            });

            storyObjects.ForEach(
                obj => {
                    try {
                        obj.cleanup();
                    }
                    catch (Exception e) {
                        Log.e($"problem cleaning up object: {obj.person.name}");
                    }
                }
            );

            scene = null;
            _instance = null;
        }

        ///////////////////////////////////////////////////
        // Various utility functions
        ///////////////////////////////////////////////////
       public void changeScene(Scene newScene) {
            StartCoroutine(doChangeScene(newScene));
        }

        IEnumerator doWhenLoaded(Action a) {
            Log.d("doWhenLoaded");
            while(SuperController.singleton.isLoading) {
                Log.d("Waiting for load to settle...");
                yield return new WaitForSeconds(1);
            }
            Log.d("*** SCENE LOADED - running post tasks ***");
            myTime = 1f;
            myActive = false;

            a();
        }

        IEnumerator doChangeScene(Scene newScene, float fadeOut = 1f, float fadeIn = 10f) {
            myTime = fadeOut;
            myActive = true;

            yield return new WaitForSeconds(fadeOut);

            //Log.d("in doCrossfade before cleanup");
            try {
                scene?.onExit();

                scene = newScene;
                scene?.setup();
                setupPov();

                scene?.state?.setStartTime();
                scene?.state?.onEnter(scene);
            } catch (Exception ex) {
                Log.d($"changin scene error {ex}");
            }

            //Log.d("in doCrossfade before unfade");

            myTime = fadeIn;
            myActive = false;

        }

        public static void ferEachActor(Action<AActor> a) {
            storyObjects.Where<AAtom>(it => it is AActor).ForEach(
                actor => a((AActor)actor)
            );
        }

        public static void forEachObject(Action<AAtom> a) {
            storyObjects.Where<AAtom>(it => !(it is AActor)).ForEach(
                obj => a(obj)
            );
        }


        void dumpAllObjects() {
            GameObject[] allObjects = UnityEngine.Object.FindObjectsOfType<GameObject>();
            foreach(GameObject go in allObjects) {
                if (go.ToString().ToLower().Contains("hands")) {
                    Log.d($"{go} is an active object");
                    var kompsy = go.GetComponentsInChildren<Component>();
                    foreach(Component co in kompsy) {
                        Log.d($"  {co} is a component");
                    }
                    var mbsy = go.GetComponentsInChildren<MonoBehaviour>();
                    foreach(MonoBehaviour co in mbsy) {
                        Log.d($"  {co} is a mb");
                    }
                }
            }
        }

        private void togglePov() {
            firstPerson = !firstPerson;
            setupPov();
        }
        private void setupPov() {
            if(scene?.male != null) {
                try {
                    if(firstPerson) {
                        Player.singleton.removeFakeBodyParts();
                        Player.singleton.unregisterColliders();
                    }
                    else {
                        StartCoroutine(Player.singleton.addFakeBodyParts());
                        Player.singleton.registerColliders();
                    }
                } catch (Exception ex) {
                    Log.d($"Problem processing player colliders:{ex}");
                }
                scene.male?.setupPov(firstPerson);
                if(firstPerson)
                    scene.female.manageTouch.val = true;
            } 
        }

        IEnumerable<Atom> findObjectsAtomsWithName(string name) {
            return GetSceneAtoms()
                .Where(atom =>  
                    {
                        return atom.name.StartsWith(name);
                    }
                );
        }

        IEnumerable<Atom> findPersonAtoms() {
            return GetSceneAtoms()
                .Where(atom =>  
                    {
                        var person = atom.GetComponentInChildren<DAZCharacterSelector>();
                        return person != null;
                    }
                );
        }
    }
}
