namespace Amaimon {
    public interface IIntensityProperty {
        float current { get; set; }
        void reset();
    }

    public abstract class IntensityProperty : IIntensityProperty {
        float _current = 0;

        public float current {
            get {
                return _current;
            }
            set {
                if(_current != value) {
                    _current = value;
                    apply(value);
                }
            }
        }

        public IntensityProperty() {
            apply(current);
        }

        public abstract void apply(float value);
        public void reset() 
        {
            current = 0;
        }

    }
}