using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using SimpleJSON;

namespace Amaimon {
    public partial class AActor : AAtom {

        public class PriorityEntry {
            public PriorityEntry(UniversalRigidbody rb) {
                body = rb;
            }
            public UniversalRigidbody body;
            public float cooldownCounter = 0;
            //public float basePrio;
            public override string ToString () {
                return $"({body.name} v={body.velocity.magnitude})";
            }
        }

        public void interestOff() {
            interestTable.clear();
        }

        public void addInterestOn(AAtom whom) {
            whom.getInterests().ForEach(iner => {
                // base priotiry for priority entry has to be set, otherwise it won't be randomly choosen at all!
                interestTable.add(new PriorityEntry(iner),0);
            });
            //Log.d($"po dodaniu Intetre={interestTable.isEmpty()}");
        }

        override public List<UniversalRigidbody> getInterests() {
            var list = new List<UniversalRigidbody>();

            list.Add(getUniversalRigidbody("rHand"));
            list.Add(getUniversalRigidbody("lHand"));
            list.Add(getUniversalRigidbody("head"));
            list.Add(getUniversalRigidbody("abdomen"));
            list.Add(getUniversalRigidbody("abdomen2"));
            list.Add(getUniversalRigidbody("rShldr"));
            list.Add(getUniversalRigidbody("lShldr"));
            list.Add(getUniversalRigidbody("chest"));
            list.Add(getUniversalRigidbody("hip"));
            list.Add(getUniversalRigidbody("pelvis"));


            var gen = getUniversalRigidbody("Gen3"); 
            if(gen!=null)
                list.Add(gen);

            return list;
        }

        public void checkPreempt() {
            if(interestTable?.isEmpty() == true) 
                return;

            PriorityEntry preempt = null;
            
            interestTable.entries.ForEach(i => {
                if(i.entry.body.velocity.magnitude > 0.5) {
                    preempt = i.entry;
                }
            });

            if(preempt != null)
                lookTowards(preempt.body.transform.position, false, 1f);
        }

        public float prioritizeInterestPoints() {
            if(interestTable.isEmpty()) 
                return 0f;

            lookArousalDt = 1/1000f;

            interestTable.entries.ForEach(i => {

                var priorityEntry = i.entry;

                float basePrio = i.priority;

                try {
                    var x = priorityEntry.body.velocity.magnitude;
                }
                catch (Exception ex) {
                    Log.d($"WARN: body null in priority table");
                    interestTable.dump();
                }


                if(priorityEntry.body.velocity.magnitude <= 0.009) {
                    basePrio -= 1;
                }

                var dist = Vector3.Distance(headRb.transform.position, priorityEntry.body.transform.position);

                if(dist < 10f) {
                    if(priorityEntry.body.name == "head")
                        basePrio += 15 - dist;
                    else
                        basePrio += 10 - dist;

                }

                if(basePrio <1)
                    basePrio = 1;

                i.priority = basePrio;

            });

            interestTable.prioritiesToChance();


            var randomTarget = interestTable.getRandom();
            var headRotationTime = 2f;

            if(randomTarget != null && randomTarget.body != null) {

                interestDoSaccade = randomTarget.body.saccade;

                interestTable.normalize();
                //interestTable.dump();

                lookTowards(randomTarget.body.transform.position, false, headRotationTime);

                var lookTime = getScaredRelaxedInterval();

                if(randomTarget.body.niceName().Contains("gen")) {
                    if(scaredRelaxed>=0) {
                        maybeExpression(getAmazeMorphs(0.7f).getRandom(),2);
                        if(isMale())
                            lookArousalDt = 1/40f;
                        else
                            lookArousalDt = 1/220f;
                    }
                    else
                        maybeExpression(getDisgustMorphs(1f).getRandom());
                }
                else if(randomTarget.body.niceName().Contains("head")) {
                    if(scaredRelaxed>=0) {
                        maybeExpression(getAttractedMorphs(1f).getRandom(),5);
                        lookArousalDt = 1/400f;
                    }
                }
                else if(randomTarget.body.niceName().Contains("abdomen") || randomTarget.body.niceName().Contains("chest")) {
                    if(scaredRelaxed>=0) {
                        if(isMale())
                            lookArousalDt = 1/60f;
                        else
                            lookArousalDt = 1/440f;

                        maybeExpression(getAmazeMorphs(0.7f).getRandom(),2);
                    }
                }

                return lookTime;
            }
            else
                return 0f;
            
        }
    }
}