using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;
using UnityEngine.Windows.Speech;

using SimpleJSON;

using MVR.FileManagementSecure;
using MVR.FileManagement;

namespace Amaimon {


    public class MaleActor : AActor {
        public MaleActor(Atom a) : base(a) {

        }

        override public bool isMale() {
            return true;
        }

        public override RandomTable<ExpressionMorph> getDisgustMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Snarl Left", 1f, 1f, 0.5f), 1f)
            .add(new ExpressionMorph(this, "Contempt", 0.5f, 1f, 0.5f), 1f)
            .add(new ExpressionMorph(this, "Disgust", 0.5f, 1f, 0.5f), 1f);
        }

        public override RandomTable<ExpressionMorph> getScaredMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Afraid", power, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Scream", power, 0.8f, 2f),1f)
            .add(new ExpressionMorph(this, "Fear", power, 0.7f, 2f),1f);
        }

        public override RandomTable<ExpressionMorph> getSpankedMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Frown", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Shock", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Pain", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Sad", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Glare", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Confused", 1f, 0.25f, 2f),1f);
        }

        public override RandomTable<ExpressionMorph> getSadMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Sad", 1f, 0.25f, 2f),1f);
        }

        public override RandomTable<ExpressionMorph> getHappyMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Smile Full Face", 1f, 1f, 0.5f),1f)
            .add(new ExpressionMorph(this, "Smile Open Full Face", 0.6f, 1f, 0.5f),1f)
            .add(new ExpressionMorph(this, "Happy", 0.5f, 1f, 0.5f),1f);
        }

        public override RandomTable<ExpressionMorph> getAttractedMorphs(float power) {
           var sustain = 0.8f;
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Alluring", 1f, 1f, 1f, 3f),10f)
            .add(new ExpressionMorph(this, "Flirting", 1f, 1f, 1f, 3f),10f)
            .add(new ExpressionMorph(this, "Excitement", 0.7f, 1f, 1f, 3f),10f)
            .add(new ExpressionMorph(this, "Desire", 1f, 1f, 1f, 3f),10f)
            .add(new ExpressionMorph(this, "Sexy", 0.6f, 1f, 1f, 3f),10f);
        }

        public override RandomTable<ExpressionMorph> getExcitedMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Excitement", 0.7f, 1f, 1f, 3f),10f);
        }
 
        public override RandomTable<ExpressionMorph> getAmazeMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Surprise", 0.6f, 0.25f, 2f),1f);
        }

        public override RandomTable<ExpressionMorph> getSmilesMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Smile Full Face", 1f, 1f, 0.5f),1f)
            .add(new ExpressionMorph(this, "Smile Open Full Face", 0.6f, 1f, 0.5f),1f)
            .add(new ExpressionMorph(this, "Happy", 0.5f, 1f, 0.5f),1f);
        }

        public override RandomTable<ExpressionMorph> getLipTouchMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "LipsFunnel", 0.8f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "LipsPucker", 0.7f, 0.25f, 2f),1f)
            ;
        }

        public override RandomTable<ExpressionMorph> getHeadTouchMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Alluring", 0.6f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Excitement", 0.5f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Happy", 0.25f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Smile Full Face", 0.8f, 0.25f, 2f),1f)
            ;
        }

        public override RandomTable<ExpressionMorph> getGenitalTouchMorphs(float power=1) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Happy", 0.5f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Excitement", 0.9f, 0.25f, 2f),1f)
            ;
        }
 
         public override RandomTable<ExpressionMorph> getPleasureMorphs(float power=1) {
           return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Happy", 0.5f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Smile Full Face", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Exaggerating", 1f, 0.25f, 2f),1f);
        }

        public override RandomTable<ExpressionMorph> getKissMorphs(float power=1) {
           return RandomTable<ExpressionMorph>.create();
        }

    }



    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    public class FemaleActor : AActor {
        public FemaleActor(Atom a) : base(a) {

        }

        override public bool isMale() {
            return false;
        }

        // NEGATYWNE:

       // OBRZYDZENIE: "Disgust" (0.5) CS_Paige_Doubtful1 (1); CS_Paige_Gross1 (0.5); "Contempt" (0.5); Sneer (1); Mouth 12 (0.3); Mouth 2 (0.5)
        public override RandomTable<ExpressionMorph> getDisgustMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Disgust", 0.5f, 1f, 0.5f), 1f)
            .add(new ExpressionMorph(this, "CS_Paige_Doubtful1", 1f, 1f, 0.5f), 1f)
            .add(new ExpressionMorph(this, "CS_Paige_Gross1", 0.5f, 1f, 0.5f), 1f)
            .add(new ExpressionMorph(this, "Contempt", 0.5f, 1f, 0.5f), 1f)
            .add(new ExpressionMorph(this, "Sneer", 1f, 1f, 0.5f), 1f)
            .add(new ExpressionMorph(this, "Mouth 12", 0.3f, 1f, 0.5f), 1f)
            .add(new ExpressionMorph(this, "Mouth 2", 0.5f, 1f, 0.5f), 1f);
        }


    // STRACH: "Fear" (0.5), "Pain" (0.5) "Scream" v2 AA - Fear1/2 (0.4), v2 Terrified1/2 (0.6); Scared1/2 (0.6); CS_Paige_Miffed1 0.5;
    // CS_Paige_Nervous1 (0.7); CS_Paige_Wary1 (1); Base_Embarrased (1); CTY_BASE (0.5); 


        public override RandomTable<ExpressionMorph> getScaredMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Fear", 0.5f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Pain", 0.5f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Scream", 0.3f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Fear 1", 0.4f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Fear 2", 0.4f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Terrified1", 0.6f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Terrified2", 0.6f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Scared1", 0.6f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Scared2", 0.6f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "CS_Paige_Miffed1", 0.5f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "CS_Paige_Nervous1", 0.7f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "CS_Paige_Wary1", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Base_Embarassed", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "CTY_BASE", 0.5f, 0.25f, 2f),1f);
        }

    // PO KLAPSIE: "v3 Deserving It"1, Eyes 04 (1); Stifled1 (0.5); Stifled3 (1); Pain (0.7); AA - Pain 1/2/3 (1); CTY_Base2 (1);
    // frown - obrzydzenia, złości itp.


        public override RandomTable<ExpressionMorph> getSpankedMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Deserving It", 1f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "Eyes 04", 1f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "Stifled1", 0.5f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "Stifled3", 0.5f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "Pain", 0.6f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "CTY_Base2", 1f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Pain 1", 1f, 1f, 2f),1f);
        }

    // SMUTEK: "v3 Pouty" (0.6) - podkówka bez oczu, "Sad" (0.5); v2 AA - Worry 1/2 (0.4); v2 Unhappy1/2 (0.6); "Tears Grief 2"(0.7); AA - Sad 1/2(0.1); 
    // "Confused" (1) - prawie płaczliwie; Brows 01 (1); Brows 05a/b (0.5);

        public override RandomTable<ExpressionMorph> getSadMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Pouty", 0.6f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Sad", 0.5f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Worry 1", 0.4f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Worry 2", 0.4f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Unhappy1", 0.6f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Unhappy2", 0.6f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Tears Grief 2", 0.7f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Sad 1", 0.1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Sad 2", 0.1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Confused", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Brows 01", 1f, 0.25f, 2f),1f)
            .add(new ExpressionMorph(this, "Brows 05a", 0.5f, 0.5f, 2f),1f)
            .add(new ExpressionMorph(this, "Brows 05a", 0.5f, 0.25f, 2f),1f);
        }

    // GNIEW: v2 AA - Anger 1 (0.5), v2 AA - Anger 2 (0.5), v2 - Annoyed 1 (0.4) - przewraca oczami; "Angry" (0.5); CS_Paige_Angry1 0.5; CS_Paige_Shushing1 (0.7)
    // "Glare" (0.5) Brows 02 (1)

    // NUDA: CS_Paige_Chill1 (0.9); v2 Bored1 (1); Mouth 7a/b (0.7) nudny uśmiesszek półgębkiem

    // ZMĘCZENIE: CS_Paige_Exhausted1 (0.5-0.6) oddech; Tired(0.5 - 0.8)

    // POZYTYWNE:

    // UŚMIECH: KEIKO smile pt (0.6); KYOUCO smile (1); Huge Smile (0.3); Babul_NSmileGood (0.9); Perfect Smile (0.5); Timbo Amazing Smile v10 (1)
    // MouthSmile (0.4); JoyBoy's Smile Pre (0.5); Mouth 1 (1); SmileOpen2_EVER (0.5)
    // BasicSmileLight (1), BasicSmileMore (0.3), "Snarl Left"/Right (0.5)  "TB-Smile Simple" (0.5) łagodny, fajny  "Half Smile"(0.5 - 0.8) 
    // Happy1(0.5 - 0.8) v2 AA - Smile 1/2 (0.4),  "Just smile"(0.37),  (0.5)  "Smile Full Face" (0.5)-sztuczny "Smile Open Full Face"(0.2)
    // PassiveSmile(0.5 - 0.8) Peaceful(0.5 - 0.8)  SweetDream(0.5 - 0.8) Timid(0.5 - 0.8)

        public override RandomTable<ExpressionMorph> getHappyMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "TB-Smile Simple", 0.5f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "KEIKO smile pt", 0.2f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "KYOUCO smile", 1f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "Huge Smile", 0.2f, 1f, 2f),1f)

            .add(new ExpressionMorph(this, "Babul_NSmileGood", 0.4f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "Perfect Smile", 0.36f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "BasicSmileLight", 0.5f, 1f, 2f),1f)
            .add(new ExpressionMorph(this, "Timbo Amazing Smile v10", 0.7f, 1f, 2f),1f);
        }


    // FLIRT: Wink Right(0.5 - 0.8) "Flirting" (0.5), "Flirting Feminine Left"/Right (0.5) - puszcza oczko "Flirting Masculine Left" (0.5), 
    // Foxy(0.5 - 0.8) Allure2(0.5 - 1) Alluring(0.5 - 0.8);  BlowKiss(0.5 - 0.8);  "v3 Mouth Resting" (1) - mały dziubek 

        public override RandomTable<ExpressionMorph> getAttractedMorphs(float power) {
           var sustain = 0.8f;
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Wink Right", 0.8f, 0.25f, 0.25f, 0.25f), 0.25f)
            .add(new ExpressionMorph(this, "Flirting", 0.5f, 0.5f, 0.5f, 2f), 1f)
            .add(new ExpressionMorph(this, "Flirting Feminine Right", 0.9f, 0.25f, 0.25f, 0.25f), 0.25f)
            .add(new ExpressionMorph(this, "Foxy", 0.5f, 2f, 2f, 3f),1f)
            .add(new ExpressionMorph(this, "Flirting Masculine Right", 0.5f, 0.25f, 0.25f, 0.25f), 0.25f)
            .add(new ExpressionMorph(this, "Allure2", 0.4f, 2f, 2f, 3f),1f)
            .add(new ExpressionMorph(this, "Alluring", 0.8f, 2f, 2f, 3f),1f)
            .add(new ExpressionMorph(this, "BlowKiss", 0.8f, 1f, 0.5f, 0.25f),1f)
            .add(new ExpressionMorph(this, "TB-Smile Simple", 1f, 1f, 1f, 3f),10f);
        }

    // UŚMIECH GŁUPAWY: Grin(0.5 - 0.8) 

    // PODNIECENIE: "Excitement" (0.7); "Desire" (0.4)

        public override RandomTable<ExpressionMorph> getExcitedMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Desire", 0.5f, 2f, 5f),1f)
            .add(new ExpressionMorph(this, "Excitement", 0.5f, 0.25f, 2f),1f);
        }

    // v3 It's Aight (do 1), Exaggerating (0.5)
    // AAmouth_OH2 (0.4) + przymknąć oczy + AAmouth_smileXx (do 0.5)

    // BIERNA PRZYJEMNOŚĆ: "v3 It's Aight"(1)- miło, zamknięte oczy

    // SZCZĘŚCIE: Happy1 (0.42); Happy (0.46); CS_Paige_Pleased1 (0.7)
    
    // WSAD: "v3 Enjoying It" (0.5-1), "Taking It" (1) "v3 Exaggerating"(1), XX-Extreme Pleasure (0.5); Pleasure14 (0.5)
    // ashayrunsex = masa!!! CTY_Orgasm*

    // SPOKOJNIEJSZY SEKS: v2 AA - Sexy 1/2 (1), 

    // BUZI: v2 AA - Kiss 1/2/3 (0.4), Kiss(0.5 - 1); Kiss 1 (0.9); LipsFunnel (0.5); LipsPucker (0.7)
    
    // SZOK: CS_Paige_Disbelief1 (0.5); Can't Believe It (0.5 - 0.8); Disbelief1 (0.6); NicoShock (0.5); Shock (1); Shock1 (0.5);   
    // Mouth 10 (0.3); Mouth 5 (1); Mouth 9 (0.4)

    // ZACHWYT: Mouth 11 (0.5); CS_Paige_Excited1 "wooow" (0.8); Shock2 (0.5); AA - Surprise1/2 (1); HappySurprise1/2/3 (0.6); "Surprise" (0.5); 

    // NIEPEWNOŚĆ: v2 Embrassed1/2 (0.6), "v3 F Viseme Alt"(1_-zagryza wargę,  "v3 Lip Bite" (0.5) - pół wargi, CS_Paige_Contemplating1 (1) 
    // zagryza wargę, CS_Paige_Suspicious1 (0.6); Mouth 3a/b (0.5) uśmiech półgębkiem; Timid (1)

    // ZACIEKAWIENIE: CS_Paige_Intrigued1 (1); "Concentrate"(0.5 - 0.8) Remember(0.5 - 0.8); v2 AA - Incredulous (0.4) - co by tu?; Curious(0.5 - 0.8) 
    // v2 Curious1 (0.8); v2 Curious2 (0.8); Concentration and Effort 01 (1);

    // ZGODA: "v3 Certainly" 1, Understood(0.5 - 0.8), CS_Paige_Agreed1 0.6;  CS_Paige_YeahRight1 (0.6)

    // OCZEKIWANIE:  v2 Hopeful1 (0.6) - bęzie fajne na kolanach, ze wzrokiem w górę
 
        public override RandomTable<ExpressionMorph> getAmazeMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(FemaleExpressions.Excitement(this, power),1f)
            .add(FemaleExpressions.HappySurprise(this, power), 0.5f)
            .add(FemaleExpressions.SimpleSmile(this, power), 2f)
            .add(new ExpressionMorph(this, "BlowKiss", 1f, 0.5f, 1f),0.25f);
            ;
        }

        public override RandomTable<ExpressionMorph> getSmilesMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(FemaleExpressions.Excitement(this, power),0.5f)
            .add(FemaleExpressions.Happy(this, power),1f)
            .add(FemaleExpressions.Happy1(this, power),1f)
            .add(FemaleExpressions.SimpleSmile(this, power),1f);            
        }

        public override RandomTable<ExpressionMorph> getLipTouchMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "Exaggerating", 0.5f, 0.5f, 1f),1f)
            .add(new ExpressionMorph(this, "AA - Kiss 1", 0.5f, 0.5f, 1f),1f)
            .add(new ExpressionMorph(this, "AA - Kiss 2", 0.3f, 0.5f, 1f),1f)
            .add(new ExpressionMorph(this, "AA - Kiss 3", 0.5f, 0.5f, 1f),1f)
            .add(new ExpressionMorph(this, "Mouth Open Wide", 0.3f, 0.5f, 1f),1f)
            .add(new ExpressionMorph(this, "Mouth Open Wide 2", 0.3f, 1f, 1f),1f)
            .add(new ExpressionMorph(this, "Mouth Open Wide 3", 0.3f, 1f, 1f),1f)
            .add(new ExpressionMorph(this, "BlowKiss", 1f, 0.5f, 1f),1f);
        }

        public override RandomTable<ExpressionMorph> getHeadTouchMorphs(float power) {
            return RandomTable<ExpressionMorph>.create()
                .add(FemaleExpressions.PleasureClosedEyes(this),1f)
                .add(FemaleExpressions.Kiss1(this, power),0.2f);
        }

        public override RandomTable<ExpressionMorph> getGenitalTouchMorphs(float power=1) {
            return RandomTable<ExpressionMorph>.create()
                .add(FemaleExpressions.PleasureClosedEyes(this),1f)
                .add(FemaleExpressions.TakingIt(this, power),0.5f)
                .add(FemaleExpressions.Excitement(this, power),1f);
        }
 
         public override RandomTable<ExpressionMorph> getPleasureMorphs(float power=1) {
           return RandomTable<ExpressionMorph>.create()
                .add(new ExpressionMorph(this, "It's Aight", 0.7f*power, 2f, 2f),1f)
                .add(new ExpressionMorph(this, "Taking It", power, 1f, 2f),1f)
                .add(new ExpressionMorph(this, "Excitement", 0.7f*power, 1f, 2f),1f);
        }

        public override RandomTable<ExpressionMorph> getKissMorphs(float power=1) {
           return RandomTable<ExpressionMorph>.create()
            .add(new ExpressionMorph(this, "AA - Kiss 1", 1f, 3f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Kiss 2", 1f, 3f, 2f),1f)
            .add(new ExpressionMorph(this, "AA - Kiss 3", 1f, 3f, 2f),2f);
        }

    }
}