using System.Collections.Generic;

namespace Amaimon {
    public partial class AActor : AAtom {

        public JSONStorableString info;		
        
        public JSONStorableBool manageTouch; // addHandsOn / handsOff
        public JSONStorableBool allowPushing; // addHandsOn / handsOff
        public JSONStorableBool manageInterest; // addInterestOn / iinterestOff
        public JSONStorableBool manageHead;
        public JSONStorableBool manageEmotions;
        public JSONStorableBool playerInterest;
        public JSONStorableBool playerTouch;

        public class JsonAtomPaiir {
            public JSONStorableBool enabled;
            public AAtom whom;

            public JsonAtomPaiir(JSONStorableBool jb, AAtom wh) {
                enabled = jb;
                whom = wh;
            }
        }

        
        public void addPanel(MVRScript script) {
            info = MacGruber.Utils.SetupInfoText(script,$"{person.name} settings", 5, false);

            //Log.d($"creating {person.name} panel");

            allowPushing = MacGruber.Utils.SetupToggle(script, $"{person.name} can loose balance", true, false);

            manageTouch = MacGruber.Utils.SetupToggle(script, $"{person.name} manage hands", false, false);
            StoryPlugin.ferEachActor(actor => {
                if(actor != this) {
                    var label = $"{person.name}->{actor.person.name} touch";
                    touchTargets.Add(label, new JsonAtomPaiir(MacGruber.Utils.SetupToggle(script, label, true, false), actor));
                }
            });
            var labelB = $"{person.name}->Player touch";
            playerTouch = MacGruber.Utils.SetupToggle(script, labelB, false, false);
            touchTargets.Add(labelB, new JsonAtomPaiir(playerTouch, Player.singleton));

            MacGruber.Utils.SetupSpacer(script, 10, false);
            manageInterest = MacGruber.Utils.SetupToggle(script, $"{person.name} manage eyes", true, false);
            manageHead = MacGruber.Utils.SetupToggle(script, $"{person.name} manage head", true, false);
            StoryPlugin.ferEachActor(actor => {
                //Log.d($"{person.name} tries to add {actor.person.name}");
                if(actor != this) {
                    var label = $"{person.name}->{actor.person.name} glance";
                    interestTargets.Add(label, new JsonAtomPaiir(MacGruber.Utils.SetupToggle(script, label, true, false), actor));
                }
            });
            var labelA = $"{person.name}->Player glance";
            playerInterest = MacGruber.Utils.SetupToggle(script, labelA , true, false);
            interestTargets.Add(labelA, new JsonAtomPaiir(playerInterest, Player.singleton));

            MacGruber.Utils.SetupSpacer(script, 10, false);
            manageEmotions = MacGruber.Utils.SetupToggle(script, $"{person.name} manage mood", true, false);

            MacGruber.Utils.SetupSpacer(script, 10, false);
            // UIDynamicButton SetupButton(MVRScript script, string label, UnityAction callback, bool rightSide)
            MacGruber.Utils.SetupButton(script, "Apply above settings", applySettingsFromUI, false);
            MacGruber.Utils.SetupButton(script, "Sexdoll mode", applySexdollMode, false);

            MacGruber.Utils.SetupSpacer(script, 50, false);
        }


        private void applySexdollMode() {
            humanizeJoints(false);
        }

        public void applySettingsFromUI() {
            handsOff();
            interestOff();

            playerInterest.val = !StoryPlugin.singleton.firstPerson;
            playerTouch.val = !StoryPlugin.singleton.firstPerson;

            foreach (KeyValuePair<string, JsonAtomPaiir> kvp in touchTargets)
            {
                string id = kvp.Key;
                JsonAtomPaiir value = kvp.Value;
                if(value.enabled.val)
                    addHandsOn(value.whom);
            }
            foreach (KeyValuePair<string, JsonAtomPaiir> kvp in interestTargets)
            {
                string id = kvp.Key;
                JsonAtomPaiir value = kvp.Value;
                if(value.enabled.val)
                    addInterestOn(value.whom);
            }
        }
    }
}
