using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using SimpleJSON;

namespace Amaimon {


    public class Hitter {
        public AAtom offenderAtom;
        public string offenderBodyPart;
        public String victimBodyPart;
        public float magnitude;
        public byte hitType = 0;

        public Hitter(AAtom a, string obp) {
            offenderAtom = a;
            offenderBodyPart = obp;
        }

        public override string ToString()
        {
            return $"{offenderAtom.person.name} hits({hitType}) soemone's {victimBodyPart} with {offenderBodyPart}";
        }

    }

    public partial class AActor : AAtom {
        override public List<UniversalRigidbody> getHitters() {
            var list = new List<UniversalRigidbody>();

            list.Add(getUniversalRigidbody("rHand"));
            list.Add(getUniversalRigidbody("lHand"));
            list.Add(getUniversalRigidbody("Gen3"));

            return list;
        }
        
/*

trigger:LabiaTrigger (CollisionTrigger)
trigger:VaginaTrigger (CollisionTrigger)
trigger:DeepVaginaTrigger (CollisionTrigger)
trigger:DeeperVaginaTrigger (CollisionTrigger)

trigger:LipTrigger (CollisionTrigger)
trigger:MouthTrigger (CollisionTrigger)
trigger:ThroatTrigger (CollisionTrigger)

trigger:lNippleTrigger (CollisionTrigger)
trigger:rNippleTrigger (CollisionTrigger)

*/

        class Orifice {
            public float prevDistance;
            public bool wasTriggered = false;
        }

        class PenisModel {
            Vector3 root;
            Vector3 mid;
            Vector3 tip;

            int rootLastGate;
            int midLastGate;
            int tipLastGate;

            float penetrationDepth() {
                return 0;
            }
            
            bool isInside() {
                return false;
            }
        }

        // public Vector3 getPenisVector() {
        //     // wektorPenisa = gen3 - gen1 (tip - base)

        //     // crossproduct = jeżeli mają ten sam kierunek = 0

        // // mierzymy ruch gen3 względem deepvagina i throat
        // }

        // public Vector3 getVaginaVector() {
        //     // wektor pochwy = deepervaginatrigger - labiatrigger
        // }

        // public Vector3 getThroatVector() {
        //     // wektor ust = throattrigger - mouthtrigger
        // }




        override public void unregisterColliders() {
            base.unregisterColliders();
            foreach(var component in person.GetComponentsInChildren<TriggerAnalyzer>()) {
                Log.d($"destroing {person.name}'s {component}");
                UnityEngine.Object.Destroy(component);
            }
        }

        override public void registerColliders() {
            unregisterColliders();

            base.registerColliders();

            Log.d($"{person.name} registering colliders");

            person.GetComponentsInChildren<Collider>()
                .Where(it => it.isTrigger)
                .ForEach(myTrigger => {
                    attachTriggerCallback(myTrigger.gameObject, TriggerCallback);
                });            
        }

        override public void imCollidingWith(object analyzer, CollisionEventArgs e)
        {
            var whomDidIHit = detectVictim(e);

            if(whomDidIHit != this) {
                var hitter = new Hitter(e.offender, e.offendersPart.name.ToLower());
                hitter.victimBodyPart = e.collision.rigidbody.niceName();
                hitter.hitType = e.evtType;
//                Log.d($"{person.name} got collision, victim={whomDidIHit}, hitter={hitter}");
                lastITouched = hitter;

                if(hitter.victimBodyPart=="object") {
                    Log.d($"{person.name} touched something insignificant");
                }
                if(hitter.victimBodyPart.Contains("thigh") || hitter.victimBodyPart.Contains("glute") || hitter.victimBodyPart.Contains("pelvis")) {
                    //Log.d($"{hitter} touched {whomDidIHit.person.name} thigh/glute/pelvis");
                    giveTouchArousalDt = 1/30f;
                }
                else if(hitter.victimBodyPart.Contains("chest") || hitter.victimBodyPart.Contains("pectoral")) {
                    //Log.d($"{hitter} touched {whomDidIHit.person.name} chest");
                    if(isMale()) {
                        giveTouchArousalDt = 1/15f;
                    }
                    else
                        giveTouchArousalDt = 1/20f;
                }
                else if(hitter.victimBodyPart.Contains("nipple") || hitter.victimBodyPart.Contains("labia") || hitter.victimBodyPart.Contains("gen3")|| hitter.victimBodyPart.Contains("areola")) {
                    //Log.d($"{hitter} touched {whomDidIHit.person.name} nipple/labia/gen");
                    giveTouchArousalDt = 1/10f;                    
                }
                else if(hitter.victimBodyPart.Contains("joint")) {
                    giveTouchArousalDt = 1/500f;                    
                }
                else {
                    Log.d($"NO give touch arousal for {hitter}");
                }

                whomDidIHit?.wasHitWith(hitter);
            }
        }


        override public void wasHitWith(Hitter hitter) {
            if(hitter.hitType == 2) {
                var spankAudio = spankAudioTable.getRandom();
                playAudio(spankAudio);
            }

            if(lastHit == null || lastHit.hitType != 10)
                lastHit = hitter;

            //Log.d($"COLL: {lastHit.offenderAtom.getName()}'s {lastHit.offenderBodyPart} HIT {person.name}'s {lastHit.victimBodyPart}, type={lastHit.hitType}");
        }

        // Trigger callbacks - process them here ======================================================

        void attachTriggerCallback(GameObject myTrigger, EventHandler<TriggerEventArgs> callHere) {
            var collider = myTrigger.AddComponent<TriggerAnalyzer>();
            collider.OnCollide += callHere;
            collider.forTrigger = myTrigger.name;
        }

        void TriggerCallback(object analyzer, TriggerEventArgs e) {
            if(e.trigger != null) {

                //Log.d($"{person.name} trigger touched, {e.trigger} collided with {e.collider}");
    
                var hit = createTriggerHit(e);

                if(hit != null && hit.offenderAtom != this) {
                    lastHit = hit;
                    //Log.d($"TRIG: {lastHit.offenderAtom.getName()}'s {lastHit.offenderBodyPart} TRIGGERED {person.name}'s {lastHit.victimBodyPart}");
                }
            }            
        }

        Hitter createTriggerHit(TriggerEventArgs e) {
            var collidingWith = e.collider;

            foreach (AAtom offender in StoryPlugin.storyObjects) {
                var colliders = offender.GetComponentsInChildren(collidingWith.GetType());
                foreach (Component offendersCollider in colliders) {
                    if(offendersCollider == collidingWith) {
                        var hitter = new Hitter(offender, offendersCollider.name.ToLower());
                        hitter.victimBodyPart =  e.trigger.ToLower();
                        hitter.hitType = 10;
                        return hitter;
                    }
                }
            }

            var colliders2 = Player.singleton.GetComponentsInChildren(collidingWith.GetType());
            foreach (Component offendersCollider in colliders2) {
                if(offendersCollider == collidingWith) {
                    var hitter = new Hitter(Player.singleton, offendersCollider.name.ToLower());
                    hitter.victimBodyPart = e.trigger;
                    hitter.hitType = 1;
                    return hitter;
                }
            }

            return null;
        }
    }
}