using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;
using UnityEngine.Windows.Speech;

namespace Amaimon {
    public abstract class UniversalRigidbody {
        public bool saccade = false;

        public abstract Transform transform {
            get; 
        }

        public abstract Vector3 velocity {
            get; set;
        }
        public abstract string name {
            get; set;
        }

        // used only for collistion
        public abstract GameObject gameObject {
            get;
        }

        public string niceName() {
            return name.ToLower();
        }
    }

    public class RealRigidbody : UniversalRigidbody {
        protected Rigidbody rb;

        override public Transform transform {
            get { return rb.transform; }
        }

        override public GameObject gameObject {
            get { return rb.gameObject; }
        }

        override public Vector3 velocity {
            get { return rb.velocity; }
            set { rb.velocity = value; }
        }
        override public string name {
            get { return rb.name; }
            set { rb.name = value; }
        }
        public RealRigidbody(Rigidbody r, bool sacc = false) {
            if(r == null)
                throw new Exception("rigidbody = null in RealRigidbody constructor");
            rb = r;
            saccade = sacc;
        }
    }

    public class RenamedRealRigidbody : RealRigidbody {
        
        string _name;

        public RenamedRealRigidbody(string n, Rigidbody r, bool sacc = false) : base(r, sacc) {
            _name = n;
        }

        override public string name {
            get { return _name; }
        }
    }
}