using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using SimpleJSON;

namespace Amaimon {
    class Unity {
        // Storable, i.e. a plugin
        public static JSONStorable GetStorableByPartialName(Atom atom, string pluginName)
        {
            Transform pluginsTransform = null;
            if (atom.name == "CoreControl")  pluginsTransform = atom.transform.Find("ScenePluginManager")?.Find("Plugins");
            else pluginsTransform = atom.transform.Find("reParentObject")?.Find("object")?.Find("PluginManager")?.Find("Plugins");
            if (pluginsTransform!=null){
                for (int i = 0; i < pluginsTransform.childCount; i++){
                    string receiverName = pluginsTransform.GetChild(i).gameObject.name;
                    //Log.d($"  Maybe: {receiverName}");

                    if (receiverName.EndsWith(pluginName)){
                        JSONStorable receiver = atom.GetStorableByID(receiverName);
                        return receiver;
                    }
                }
            }
        
            return null;
        }

        public static JSONStorable findPluginAnywhere(string pluginName) {
            JSONStorable storables = null;

            foreach (Atom atom in SuperController.singleton.GetAtoms()){
                //Log.d($"Looking in: {atom.name}");
                storables = Unity.GetStorableByPartialName(atom, pluginName);
                if(storables != null)
                    break;
            }

            //Log.d($"Found {pluginName} = {storables}");
            return storables;
        }

        public static AAtom GetAtomById(string name) {
            var found = SuperController.singleton.GetAtoms().FirstOrDefault(x => x?.name == name);
            if(found == null)
                return null;
            else
                return new AAtom(found);
        }
    }
}