using System;
using UnityEngine;

namespace Amaimon {
    public class UnstablePosition {
        Transform positionSource;
        Vector3 lastGood = new Vector3();
        Vector3 prevFramePos = new Vector3();
        int frameCounter;

        public UnstablePosition(Transform t) {
            positionSource = t;
        }

        public Vector3 get() {
            return lastGood;
        }
        public void nextFrame() {
            if(Vector3.Distance(positionSource.position, prevFramePos) > 0.20f)
                frameCounter = 0;
            else
                frameCounter++;

            prevFramePos = positionSource.position;

            if(frameCounter > 1) {
                lastGood = positionSource.position;
            }
        }
    }
}

