using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using System.Collections;

namespace Amaimon {
    public abstract class BaseState {
        protected long startTime;
        protected AActor male;
        protected AActor female;

        public BaseState(AActor thisA, AActor thatA) {
            male = thisA;
            female = thatA;
        }

        public void setStartTime() {
            startTime = Player.singleton.GetTimeNow();
        }

        public bool isSettled {
            get {
                return Player.singleton.GetTimeNow() - startTime > 4000;
            }
        }

        public float elapsedSeconds() {
            return (Player.singleton.GetTimeNow() - startTime)/1000;
        }

        public abstract BaseState changeIf(Scene s);
        public abstract void onRun(Scene s);
        public abstract void onEnter(Scene s);
        public abstract void onExit(Scene s);


    }
}