using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using System.Collections;
using System.Collections.Generic;
using System;

namespace Amaimon {

    public class DefaultScene : SimpleScene {
        public DefaultScene(AActor m, AActor f) : base(m, f) {
        }

        override public void onSetupScene() {     
            StoryPlugin.ferEachActor(act => {
                act.interestOff();
                act.handsOff();
                act.sadHappy = 0.8f;

                StoryPlugin.ferEachActor(other => {
                    if(act != other) {
                        act.addInterestOn(other);
                        act.addHandsOn(other);                    
                    }
                });
                act.addInterestOn(Player.singleton);

                StoryPlugin.forEachObject(obj => act.addInterestOn(obj));

                act.manageEmotions.val = true;
                act.manageInterest.val = true;
                act.manageHead.val = true;
            });

            wait(2)
            .andThen(sc => {
                female?.say("Welcome to Bhaviour plugin!", null, 5f);
            })
            .wait(5)
            ;

            if(male?.embodyPl != null) {
                andThen(sc => {
                    male.say("Ok, let me explain a few things before you do anything...", null, 5f);
                })
                .wait(5)
                .andThen(sc => {
                    male.say("I see I have Embody attached. When we stop talking, press 8 to activate it!", null, 5f);
                })
                .wait(5)
                .andThen(sc => {
                    male.say("(Note that pressing 8 is the ONLY RIGHT WAY to activate Embody within THIS DEMO SCENE!)", null, 10f);
                })
                .wait(10)
                ;
            };

            andThen(sc => {
                female?.say("Hi, I'm in a SEX DOLL mode, you can touch me and see how my body reacts...", null, 10f);
            })
            .wait(10)
            .andThen(sc => {
                female?.say("Or push me down into this bed and play with me...", null, 5f);
            })
            .wait(5)
            .andThen(sc => {
                female?.say("Even just with VR hands!", null, 3f);
            })
            .wait(3)
            .andThen(sc => {
                female?.say("Note that this plugin adds collider to PLAYER GHOST for increased immersion.", null, 5f);
            })
            ;

            if(male != null) {
                wait(5)
                .andThen(sc => {
                    if(female != null && male != null) {
                        //male.say("Oh one more thing. If you could bring her mouth close to my dick, I'm sure something would happen...", null, 10f);
                        male.say("Note that this plugin is a WORK IN PROGESS. It is designed as a DEVELOPER RESOURCE, but you my try using it in mocap scenes for added realsim.", null, 10f);
                    }
                });
            }


        }
    }

    public class DefaultState : SceneState {
        public DefaultState(AActor m, AActor f, Vector3 root) : base(m, f, root) {}

    }
}