using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using System.Collections;

namespace Amaimon {


    ///////////////////////////////////////////////////
    // SCENE: standing clothed, she's leaving
    ///////////////////////////////////////////////////

    public class DemoScene : SimpleScene {
        public DemoScene(AActor m, AActor f) : base(m, f) {
            // lightPos = new Vector3(-0.256f, 1.852f, 0.334f);
            // lightRot = Quaternion.Euler(5.28f, 325f, 2f);
        }

        override public void onSetupScene() {
            female.interestOff();
            male.interestOff();            

            male.position = new Vector3(1.662f, 0.226f, 1.681f);
            male.rotation = Quaternion.Euler(4.52f, 232.16f, 9.38f);

            male.manageEmotions.val = false;

            female.rightHand.fist();
            female.leftHand.fist();

            female.manageEmotions.val = false;
            female.handsOff();


            female.setBreathLength(0);

            female.loadPose("Custom/Atom/Person/Pose/Female/Standing/Legs Apart/Preset_395.vap");

            // eye target = 1.092 2.588 -0.588

            // male.leftHand.upYours();
            // male.rightHand.aveSatan();

            // female.leftHand.point();
            // female.rightHand.heart();


            var maleFace = male.fuzzyGetTransform("head");

            wait(0)
            .andThen(sc => {
                female.say("Hey, don't you think the girls in almost all VAM scenes look a bit...", null, 3f);
                //female.lookTowards(maleFace.position);
            })
            .wait(3.0f)
            .andThen(sc => {
                female.say("lifeless?", null, 2f);
                //female.lookTowards(maleFace.position);

            })
            .wait(2.0f)
            .andThen(sc => {
                female.say("Even when they start doing something like this...", null, 4f);
            })
            .wait(1)
            .andThen(sc => {
                female.actingChannel.run(new HumpCycle(female, "hipControl", 100f, 0.5f, 5f));
            })
            .wait(3)
            .andThen(sc => {
                female.say("It just looks creepy, not sexy...", null, 3f);
            })
            .wait(2)
            .andThen(sc => {
                female.say("Doesn't it?...", null, 2f);

                //sc.setState(new WaitingForLook(male, female, new Vector3()));
            })
            .wait(2)
            .andThen(sc => {
                female.say("But can we do anything about it?...", null, 2f);
            })
            .wait(2)
            .andThen(sc => {
                female.say("I guess we can!", new ExpressionMorph(female, "Expression-NaughtySmile", 0.7f, 1f, 2.5f, 0.25f), 1f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
                female.leftHand.controller.currentPositionState = FreeControllerV3.PositionState.Off;
                female.leftHand.controller.currentRotationState = FreeControllerV3.RotationState.Off;
                female.getController("lElbowControl").currentPositionState = FreeControllerV3.PositionState.Off;
                female.getController("lElbowControl").currentRotationState = FreeControllerV3.RotationState.Off;
                female.rightHand.controller.transform.position += Vector3.right * 0.10f;

                female.rightHand.finger[0].openClose(-0.7f, false);
                female.rightHand.finger[1].openClose(-0.7f, false);    
                female.rightHand.finger[2].openClose(-0.7f, false);    
                female.rightHand.finger[3].openClose(-0.7f, false);    
                female.rightHand.finger[4].openClose(-0.7f, false);    

            })
            .wait(2)
            .andThen(sc => {
                female.say("First - to look alive we should BREATHE some life into this body...", new ExpressionMorph(female, "Remember", 0.9f, 0.25f, 2.5f, 0.25f), 7f);
                female.rightHand.finger[0].openClose(-0.7f, false);
                female.rightHand.finger[1].openClose(1.8f, false);    
                female.rightHand.finger[2].openClose(-0.7f, false);    
                female.rightHand.finger[3].openClose(-0.7f, false);    
                female.rightHand.finger[4].openClose(-0.7f, false);    
            })


            .wait(2)
            .andThen(sc => {
                female.say("Second - I need to gaze at something to look AWARE...", new ExpressionMorph(female, "AA - Incredulous", 0.9f, 0.25f, 2.5f, 0.25f), 7f);
                female.rightHand.finger[0].openClose(-0.7f, false);
                female.rightHand.finger[1].openClose(1.8f, false);    
                female.rightHand.finger[2].openClose(1.8f, false);    
                female.rightHand.finger[3].openClose(-0.7f, false);    
                female.rightHand.finger[4].openClose(-0.7f, false);    
            })


            .wait(2)
            .andThen(sc => {
                female.say("Third - I should be able to INTERACT with my environent", new ExpressionMorph(female, "Curious1", 0.9f, 0.25f, 2.5f, 0.25f), 7f);
                female.rightHand.finger[0].openClose(-0.7f, false);
                female.rightHand.finger[1].openClose(1.8f, false);    
                female.rightHand.finger[2].openClose(1.8f, false);    
                female.rightHand.finger[3].openClose(1.8f, false);    
                female.rightHand.finger[4].openClose(-0.7f, false);    
            })

            .wait(2)
            .andThen(sc => {
                female.say("Fourth - the environment (YOU!) should be able to interact with me!", new ExpressionMorph(female, "Expression-NaughtySmile", 0.7f, 1f, 2.5f, 0.25f), 7f);
                female.rightHand.finger[0].openClose(-0.7f, false);
                female.rightHand.finger[1].openClose(1.8f, false);    
                female.rightHand.finger[2].openClose(1.8f, false);    
                female.rightHand.finger[3].openClose(1.8f, false);    
                female.rightHand.finger[4].openClose(1.8f, false);    
            })


            .wait(2)
            .andThen(sc => {
                female.leftHand.relaxed();
                female.rightHand.relaxed();
                female.leftHand.controller.currentPositionState = FreeControllerV3.PositionState.Off;
                female.leftHand.controller.currentRotationState = FreeControllerV3.RotationState.Off;
                female.rightHand.controller.currentPositionState = FreeControllerV3.PositionState.Off;
                female.rightHand.controller.currentRotationState = FreeControllerV3.RotationState.Off;

                female.say("Ok. So let's start with breathing", null, 4f);
                female.setBreathLength(2);
            })
            .wait(2)
            .andThen(sc => {
                female.say("Take a moment to observe how my chest, belly and shoulders move while breathing...", null, 6f);
            })
            .wait(6)
            .andThen(sc => {
                female.setBreathLength(0.8f);
                female.addInterestOn(male);   

                female.say("This plugin changes my breathing rate, depending on if I'm relexed, scared or aroused.", null, 6f);
            })
            .wait(4)
            .andThen(sc => {
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
                female.say("Oh, sorry I wasn't looking at you...", null, 3f);
            })
            .wait(3)
            .andThen(sc => {
                female.say("But there's this hung guy I just can't take my eyes off...", null, 5f);
            })
            .wait(5)
            .andThen(sc => {
                female.setBreathLength(2f);
                female.say("Let's bring him into the picture!", null, 5f);
                // male.position = new Vector3(0.719f, -0.013f, 0.275f);

                var slowMover = new VectorInterpolator(male.getController("control").transform, new Vector3(0.719f, -0.013f, 0.275f), 1.5f);

                sc.registerPhysics(slowMover);

                male.rotation = Quaternion.Euler(7.44f, 251.18f, 3.49f);
                female.sadHappy = 0.9f;

            })
            .wait(5)
            .andThen(sc => {
                female.say("Fuck YESSS!!!", new ExpressionMorph(female, "Expression-NaughtySmile", 0.7f, 1f, 2.5f, 0.25f), 3f);
            })
            .wait(3)
            .andThen(sc => {
                female.say("I gotta tell you...", null, 3f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
            })
            .wait(3)
            .andThen(sc => {
                female.say("When I see a guy like this...", new ExpressionMorph(female, "Expression-NaughtySmile", 0.7f, 1f, 2.5f, 0.25f), 3f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
            })
            .wait(3)
            .andThen(sc => {
                female.say("I just can't keep my hands off HIM!", null, 3f);
                female.addHandsOn(male);
            })
            .wait(3)
            .andThen(sc => {
                female.say("If you haven't noticed, we've ticked off the three points...", null, 5f);
            })
            .wait(5)
            .andThen(sc => {
                female.say("Note that both gaze and touching animations are completely random...", null, 5f);
            })
            .wait(5)
            .andThen(sc => {
                female.say("Of course I will FOCUS on different parts of his body depending on my mood, arousal etc...", null, 5f);
            })
            .wait(5)
            .andThen(sc => {
                female.say("But to show you the last point I will need YOU!", null, 3f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
            })
            .wait(3)
            .andThen(sc => {
                female.say("So either use your VR hands or grab this guy's hands and start touching my erogenous zones!", null, 6f);
            })
            .wait(5)
            .andThen(sc => {
                female.say("If you know where they are...", null, 6f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
            })
            .wait(10)
            .andThen(sc => {
                female.say("When I become aroused, my nipples become erect, my breasts become firmer, and a lot of changes will happen down there, too...", null, 10f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
            })
            .wait(10)
            .andThen(sc => {
                female.say("I will react differently if either of you hit me...", null, 6f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("Because, you know, some girls might like it.", new ExpressionMorph(female, "Expression-NaughtySmile", 0.7f, 1f, 2.5f, 0.25f), 6f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("Now for some technical details.", null, 4f);
            })
            .wait(4)
            .andThen(sc => {
                female.say("Although a SINGLE instance of this plugin can breathe life into ALL persons in your scene...", null, 6f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("(making this guy touch me is just flipping a single bool)", null, 6f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("...and it plays EXTREMELY well with others like, handjob, kiss or sex plugins...", null, 6f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("...this plugin is really useful especially to people who know how to code.", null, 6f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("It's more of a high-level API/library to VAM.", null, 6f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("(Scripting this scene took about an hour).", null, 6f);
            })
            .wait(4)
            .andThen(sc => {
                female.say("It's a work in progress, but makes creating immersive and interactive scenes a breeze.", null, 6f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("It has a lot of features I didn't mention, and a lot more will come!", null, 6f);
            })
            .wait(6)
            .andThen(sc => {
                female.say("So stay ERECT as there's MORE to COME!", new ExpressionMorph(female, "Flirting Feminine Left", 0.5f, 1f, 2.5f, 0.25f), 6f);
                female.lookTowards(Player.singleton.getHeadTransform().position,true, 1f);
            })

            ;
                // Log.d("LeavingForPartyScene koniec on setup");
        }
    }


}