using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using System.Collections;
using System.Collections.Generic;
using System;

namespace Amaimon {

    public class DialogueEntry {
                    // st_time, ed_time, name, max_power, attack, decay
        public float startTime;
        float endTime;
        string name;
        float maxPower;
        float attack;
        float decay;
        public Action<Scene> action;

        public DialogueEntry(float st, float et, string n, float mp, float at, float de, Action<Scene> ac) {
            startTime = st;
            endTime = et;
            name = n;
            maxPower = mp;
            attack = at;
            decay = de;
            action = ac;
        }

        public ExpressionMorph getMorph(AActor actor) {
            var m = new ExpressionMorph(actor, name, maxPower, attack, decay, 1f);
            var duration = startTime - endTime;
            m.fitInto(duration);
            return m;
        }
    }

    public class FilmScene : SimpleScene {
        public FilmScene(AActor m, AActor f) : base(m, f) {
        }

        public void runAudioWithTimeline(List<DialogueEntry> list, AActor actor, string clipName) {
            actor.sayAudio(clipName);
            list.ForEach(entry => {
                after(entry.startTime, sc => {
                    female.preemptExpression(entry.getMorph(actor));
                    entry.action(sc);
                });            

            });
        }

        override public void onSetupScene() {     
            if(female != null) {                    
                Log.d($"Setting up scene");

                female.interestOff();
                female.handsOff();
                female.manageHead.val = true;
                female.manageInterest.val = true;

                female.scaredRelaxed = 0.1f;
                female.sadHappy = 0.1f;


                //female.addInterestOn(Player.singleton);
            }

            if(male != null) {
                male.interestOff();
                male.handsOff();

                male.manageEmotions.val = false;
                if(female != null) {
                    male.addInterestOn(female);
                    male.addHandsOn(female);
                }
            }

            wait(5)
            
            // st_time, ed_time, name, max_power, attack, decay

            // 0 Louie? - zaskoczenie
            .after(0, sc => {
                female.sayAudio("Stella - First Words.wav");
                Log.d("Louie");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Surprise1", 0.4f, 0.25f, 1f, 1f));

            })
            // 1-2,7 how's my favourite baby - flirt
            .after(1f, sc => {
                Log.d("how's my favourite ba");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Alluring", 1f, 0.25f, 1f, 2f));

            })
            // 4,677-6,122 I'm at home right now - oznajmujące
            .after(4.677f, sc => {
                Log.d("I'm at home right n");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                //female.preemptExpression(new ExpressionMorph(female, "Foxy", 0.7f, 1f, 0.5f, 0.25f));

            })
            // 8,247-9,192 Whas the matter louie - lekki strach
            .after(8.247f, sc => {
                Log.d("Whas the matter louie ");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "CS_Paige_Suspicious1", 1f, 0.25f, 3f, 1f));

            })
            // 9,627-10,551 Is everything allright? - lekki strach
            .after(9.627f, sc => {
                Log.d("Is everything allrig");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                //female.preemptExpression(new ExpressionMorph(female, "Foxy", 0.7f, 1f, 0.5f, 0.25f));

            })
            // 13,222-15,599 I'm on top of them you're all clear - uspokajająco
            .after(13.222f, sc => {
                Log.d("I'm on top of them you'");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Remember", 0.4f, 0.5f, 0.5f, 2f));

            })
            // 17,521-19,735 That was fun. What now? - jak kotka
            .after(17.521f, sc => {
                Log.d("That was fun. What ");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "AA - Sexy 1", 1f, 1f, 0.5f, 0.25f));

            })
            // 21,172-22,121 Wanna come for a drink? - z nadzieją
            .after(21.172f, sc => {
                Log.d("Wanna come for a drink");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Hopeful1", 0.6f, 1f, 0.5f, 0.25f));

            })
            // 22,385-23-123 You... dont have to stey long - zalotnie
            .after(22.385f, sc => {
                Log.d("You... dont have to stey");
                female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Alluring", 1f, 1f, 0.5f, 0.25f));

            })
            // 27,091-28,911 śmiech
            .after(27.091f, sc => {
                Log.d("śmiech");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Perfect Smile", 0.4f, 1f, 0.5f, 2f));

            })
            // 28,955-29,253 wdech
            .after(28.955f, sc => {
                Log.d("wdech");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "AAmouth_AA1", 0.4f, 0.1f, 0.2f, 0.25f));

            })
            // 29,261-32,505 Remember that guy the time you almost lost the shipping containers - wesoło
            .after(29.261f, sc => {
                Log.d("Remember that guy the time");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "KEIKO smile pt", 0.35f, 1f, 0.5f, 2f));

            })
            // 33,592-34,606 The woman that you pay - przypominając soie
            .after(33.592f, sc => {
                Log.d("The woman that you pay");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "CS_Paige_Contemplating1", 1f, 1f, 0.5f, 0.25f));

            })
            // 34,866-36,572 śmiech
            .after(34.866f, sc => {
                Log.d("śmiech");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Perfect Smile", 0.4f, 1f, 0.5f, 2f));
            })
            // 36,722-38,770 I miss those shipping containers - przez śmiech
            .after(36.722f, sc => {
                Log.d("I miss those shipping contai");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "KEIKO smile pt", 0.35f, 1f, 0.5f, 0.25f));

            })
            // 42,112-42,670 Louie? - niepewnie
            .after(42.112f, sc => {
                Log.d("Louie?");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Curious1", 0.8f, 1f, 0.5f, 0.25f));

            })
            // 43,427-44,506 Louie... - seksownie
            .after(43.427f, sc => {
                Log.d("Louie...");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Alluring", 1f, 1f, 0.5f, 0.25f));

            })
            // 46,187-46,753 Louie - zniecierpliwiona
            .after(46.187f, sc => {
                Log.d("Louie");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "CS_Paige_Chill1", 0.7f, 1f, 0.5f, 0.25f));

            })
            // 47,563-49,159 Come upstairs - seksownie
            .after(47.563f, sc => {
                Log.d("Come upstairs");
                //female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                female.preemptExpression(new ExpressionMorph(female, "Alluring", 1f, 1f, 0.5f, 0.25f));

            })
            
            ;

        }
    }

}