using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;

using System.Collections;
using System.Collections.Generic;
using System;

namespace Amaimon {
    ///////////////////////////////////////////////////
    // SCENE: standing clothed, she's leaving
    ///////////////////////////////////////////////////

    public class LeavingForPartyScene : SimpleScene {
        public LeavingForPartyScene(AActor m, AActor f) : base(m, f) {
            lightPos = new Vector3(-0.256f, 1.852f, 0.334f);
            lightRot = Quaternion.Euler(5.28f, 325f, 2f);
        }

        override public void onSetupScene() {        
            male.interestOff();
            male.handsOff();
            male.interestOff();
            male.manageEmotions.val = false;

            female.interestOff();
            female.handsOff();
            female.addInterestOn(male);   
            //female.addHandsOn(male);

            var maleFace = male.fuzzyGetTransform("head");

            wait(2)
            .andThen(sc => {
                female.say("Hey, before I go, can I ask you something?", null, 4f);
                female.lookTowards(maleFace.position);
            })
            .wait(4.0f)
            .andThen(sc => {
                female.say("Does my ass look big in this?", FemaleExpressions.Curious(female), 4f);
                female.actingChannel.run(new SwingCycle(female, "hipControl", 50f, 1f, 5f));
                female.lookTowards(maleFace.position);
            })
            .wait(4)
            .andThen(sc => {
                female.queueExpression(FemaleExpressions.FlirtingF(female));
                female.lookTowards(maleFace.position);
            })
            .wait(2)
            .andThen(sc => {
                sc.setState(new WaitingForLook(male, female, new Vector3()));
            })
            ;
                // Log.d("LeavingForPartyScene koniec on setup");

        }
    }

    ///////////////////////////////////////////////////
    // STATE: posing and asking
    ///////////////////////////////////////////////////

    public class PosingState : SceneState {
        public PosingState(AActor m, AActor f, Vector3 root) : base(m, f, root) {
            orifice = "";
        }

        override public void onEnter(Scene s) {
            Log.d("posing state enter");


            male.loadPose("Custom/Atom/Person/Pose/Male/Standing/Preset_KidnapperSuccubusReleaseEndingCockKiss.vap");
            male.loadClothingPreset("Custom/Atom/Person/Clothing/Story/Preset_SweaterJeansM.vap");
            male.position = new Vector3(0.472f, 0f, 0.447f);
            male.rotation = new Quaternion();

            female.loadPose("Custom/Atom/Person/Pose/Female/Standing/Legs Apart/Preset_441.vap");
            female.loadClothingPreset("Custom/Atom/Person/Clothing/Story/Preset_How Do I look.vap");
            female.position = new Vector3(0.493f, 0f, 1.043f);
            female.rotation = Quaternion.Euler(0f, 230f, 0f);
        }
    }

    ///////////////////////////////////////////////////
    // STATE: waiting for a look
    ///////////////////////////////////////////////////

    public class WaitingForLook : SceneState {
        public WaitingForLook(AActor m, AActor f, Vector3 root) : base(m, f, root) {}

        // obviously - root not needed here!
        bool sawTits = false;
        bool sawAss = false;

        override public void onRun(Scene s) {

            if(Player.singleton.isLookingTowards(female, "chest", 15f) && !sawTits) {
                sawTits = true;
                s.waitFromHere(0)
                .andThen(sc => {
                    var maleFace = male.fuzzyGetTransform("head");
                    female.lookTowards(maleFace.position);
                    female.actingChannel.run(new HoolaCycle(female, "headControl", 10f, 1f, 3f));
                })
                .wait(2)
                .andThen(sc => {
                    var maleFace = male.fuzzyGetTransform("head");
                    female.lookTowards(maleFace.position);
                    female.say("I said ASS!", null, 2f);
                    female.actingChannel.run(new SwingCycle(female, "hipControl", 60f, 1f, 2f));
                })
                .wait(2)
                .andThen(sc => {
                    var maleFace = male.fuzzyGetTransform("head");
                    female.lookTowards(maleFace.position);
                    female.say("Not TITS!", new ExpressionMorph(female, "Foxy", 0.7f, 1f, 0.5f, 0.25f), 2f);
                    female.actingChannel.run(new HoolaCycle(female, "chestControl", 40f, 0.50f, 1.5f));
                })
                .wait(5)
                .andThen(sc => {
                    // female.queueExpression(new ExpressionMorph(female, "Wink Right", 0.8f, 0.25f, 0.25f, 0.25f),2);
                    // female.queueExpression(new ExpressionMorph(female, "Flirting", 0.8f, 0.25f, 0.25f, 0.25f),2);
                    // female.queueExpression(new ExpressionMorph(female, "Flirting Feminine Right", 0.8f, 0.25f, 0.25f, 0.25f),2);
                    // female.queueExpression(new ExpressionMorph(female, "Foxy", 0.8f, 0.25f, 0.25f, 0.25f),2);
                    // female.queueExpression(new ExpressionMorph(female, "BlowKiss", 0.8f, 0.25f, 0.25f, 0.25f),2);
                    // female.queueExpression(new ExpressionMorph(female, "Allure2", 0.8f, 0.25f, 0.25f, 0.25f),2);
                });
            }

            else if(Player.singleton.isLookingTowards(female, "pelvis", 15f, 80f) && !sawAss) {
                sawAss = true;
                s.waitFromHere(0)
                .andThen(sc => {
                    female.say("I gained a few kilo lately, didn't I?", null, 4f);
                })
                .wait(5)
                .andThen(sc => {

                });
            }
        }
    }
}