using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

// uncomment the two lines to use as a  plugin

namespace Amaimon {

public class Audio {//: MVRScript {
        float _pitchlow = -0.07f;
        float _pitchhigh = +0.07f;

        public static string lastLoadPath;
        const string WILDCARD = "*";
        public static string[] supportedFileTypes = {WILDCARD, ".wav", ".ogg", ".mp3"}; // regex next time

        public static NamedAudioClip loadAudio(string path)
        {
            string localPath = SuperController.singleton.NormalizeLoadPath(path);
            NamedAudioClip nac;
            nac = URLAudioClipManager.singleton.GetClip(localPath);
            if (nac != null)
            {
                return nac;
            }

            URLAudioClip clip = URLAudioClipManager.singleton.QueueClip(
                SuperController.singleton.NormalizeMediaPath(path));
            if (clip == null)
            {
                return null;
            }

            nac = URLAudioClipManager.singleton.GetClip(clip.uid);
            if (nac == null)
            {
                return null;
            }
            return nac;
        }

        public static List<NamedAudioClip> loadFolder(string path, string filter="") {
            lastLoadPath = path;
            List<NamedAudioClip> clips = new List<NamedAudioClip>();
            if (filter == WILDCARD) {
                SuperController.singleton.GetFilesAtPath(path)
                    .ForEach(filePath => clips.Add(Audio.loadAudio(filePath)));
            }
            else SuperController.singleton.GetFilesAtPath(path)
                    .ForEach((filePath) =>
            {
                if (filePath.ToLower().EndsWith(filter))
                {
                    clips.Add(Audio.loadAudio(filePath));
                }
            });
            return clips;
        }
    }
}
