using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;
using UnityEngine.Windows.Speech;

using SimpleJSON;

namespace Amaimon {
    public class ClockwiseSilverBJPlugin : APlugin {
    public ClockwiseSilverBJPlugin(AActor actor) : base(actor, "ClockwiseSilver.BJ") { }
    override public void init() {
        isActive = new BoolProperty(this,"isActive");
        ToggleBJ = new ActionProperty(this,"Toggle BJ");
        Atom = new StringChooserProperty(this,"Atom");
        infoString = new StringProperty(this,"infoString");
        HeadSideSide = new FloatProperty(this,"Head Side/Side");
        HeadUpDown = new FloatProperty(this,"Head Up/Down");
        HeadFwdBkwd = new FloatProperty(this,"Head Fwd/Bkwd");
        HeadAngleXMin = new FloatProperty(this,"Head Angle X Min");
        HeadAngleXMax = new FloatProperty(this,"Head Angle X Max");
        HeadAngleYMin = new FloatProperty(this,"Head Angle Y Min");
        HeadAngleYMax = new FloatProperty(this,"Head Angle Y Max");
        HeadAngleZMin = new FloatProperty(this,"Head Angle Z Min");
        HeadAngleZMax = new FloatProperty(this,"Head Angle Z Max");
        RandomTime = new FloatProperty(this,"Random Time");
        OverallSpeed = new FloatProperty(this,"Overall Speed");
        OverallRange = new FloatProperty(this,"Overall Range");
        SFXVolume = new FloatProperty(this,"SFX Volume");
        MoanVolume = new FloatProperty(this,"Moan Volume");
        VolumeScaling = new FloatProperty(this,"Volume Scaling");
        MoanPitch = new FloatProperty(this,"Moan Pitch");
        MoanChance = new FloatProperty(this,"Moan Chance");
        ChanceScaling = new FloatProperty(this,"Chance Scaling");
        Speed = new FloatProperty(this,"Speed");
        SpeedMin = new FloatProperty(this,"Speed Min");
        SpeedMax = new FloatProperty(this,"Speed Max");
        Range = new FloatProperty(this,"Range");
        RangeMin = new FloatProperty(this,"Range Min");
        RangeMax = new FloatProperty(this,"Range Max");
        FlipLimit = new FloatProperty(this,"Flip Limit");
        TopOnlyChance = new FloatProperty(this,"Top Only Chance");
        EyesClosedMin = new FloatProperty(this,"Eyes Closed Min");
        EyesOpenTime = new FloatProperty(this,"Eyes Open Time");
        EyesClosedTime = new FloatProperty(this,"Eyes Closed Time");
        LipMorphMax = new FloatProperty(this,"Lip Morph Max");
        MouthOpenMax = new FloatProperty(this,"Mouth Open Max");
        MorphDuration = new FloatProperty(this,"Morph Duration");
        HoldSpringPos = new FloatProperty(this,"Hold Spring Pos");
        HoldSpringRot = new FloatProperty(this,"Hold Spring Rot");
    }
	
    private BoolProperty isActive;

	public void setActive(bool a) {
		isActive.set(a);
	}
	
	public bool getActive() {
		return isActive.get();
	}

	
    public ActionProperty ToggleBJ;

	
    private StringChooserProperty Atom;

	public void setTarget(AActor a) {
		Atom.set(a.person.name);
	}
	
	public string getTarget() {
		return Atom.get();
	}

	
    private StringProperty infoString;

	public void setinfoString(string a) {
		infoString.set(a);
	}
	
	public string getinfoString() {
		return infoString.get();
	}

	
    private FloatProperty HeadSideSide;

	public void setHeadSideSide(float a) {
		HeadSideSide.set(a);
	}
	
	public float getHeadSideSide() {
		return HeadSideSide.get();
	}

	
    private FloatProperty HeadUpDown;

	public void setHeadUpDown(float a) {
		HeadUpDown.set(a);
	}
	
	public float getHeadUpDown() {
		return HeadUpDown.get();
	}

	
    private FloatProperty HeadFwdBkwd;

	public void setHeadFwdBkwd(float a) {
		HeadFwdBkwd.set(a);
	}
	
	public float getHeadFwdBkwd() {
		return HeadFwdBkwd.get();
	}

	
    private FloatProperty HeadAngleXMin;

	public void setHeadAngleXMin(float a) {
		HeadAngleXMin.set(a);
	}
	
	public float getHeadAngleXMin() {
		return HeadAngleXMin.get();
	}

	
    private FloatProperty HeadAngleXMax;

	public void setHeadAngleXMax(float a) {
		HeadAngleXMax.set(a);
	}
	
	public float getHeadAngleXMax() {
		return HeadAngleXMax.get();
	}

	
    private FloatProperty HeadAngleYMin;

	public void setHeadAngleYMin(float a) {
		HeadAngleYMin.set(a);
	}
	
	public float getHeadAngleYMin() {
		return HeadAngleYMin.get();
	}

	
    private FloatProperty HeadAngleYMax;

	public void setHeadAngleYMax(float a) {
		HeadAngleYMax.set(a);
	}
	
	public float getHeadAngleYMax() {
		return HeadAngleYMax.get();
	}

	
    private FloatProperty HeadAngleZMin;

	public void setHeadAngleZMin(float a) {
		HeadAngleZMin.set(a);
	}
	
	public float getHeadAngleZMin() {
		return HeadAngleZMin.get();
	}

	
    private FloatProperty HeadAngleZMax;

	public void setHeadAngleZMax(float a) {
		HeadAngleZMax.set(a);
	}
	
	public float getHeadAngleZMax() {
		return HeadAngleZMax.get();
	}

	
    private FloatProperty RandomTime;

	public void setRandomTime(float a) {
		RandomTime.set(a);
	}
	
	public float getRandomTime() {
		return RandomTime.get();
	}

	
    private FloatProperty OverallSpeed;

	public void setOverallSpeed(float a) {
		OverallSpeed.set(a);
	}
	
	public float getOverallSpeed() {
		return OverallSpeed.get();
	}

	
    private FloatProperty OverallRange;

	public void setOverallRange(float a) {
		OverallRange.set(a);
	}
	
	public float getOverallRange() {
		return OverallRange.get();
	}

	
    private FloatProperty SFXVolume;

	public void setSFXVolume(float a) {
		SFXVolume.set(a);
	}
	
	public float getSFXVolume() {
		return SFXVolume.get();
	}

	
    private FloatProperty MoanVolume;

	public void setMoanVolume(float a) {
		MoanVolume.set(a);
	}
	
	public float getMoanVolume() {
		return MoanVolume.get();
	}

	
    private FloatProperty VolumeScaling;

	public void setVolumeScaling(float a) {
		VolumeScaling.set(a);
	}
	
	public float getVolumeScaling() {
		return VolumeScaling.get();
	}

	
    private FloatProperty MoanPitch;

	public void setMoanPitch(float a) {
		MoanPitch.set(a);
	}
	
	public float getMoanPitch() {
		return MoanPitch.get();
	}

	
    private FloatProperty MoanChance;

	public void setMoanChance(float a) {
		MoanChance.set(a);
	}
	
	public float getMoanChance() {
		return MoanChance.get();
	}

	
    private FloatProperty ChanceScaling;

	public void setChanceScaling(float a) {
		ChanceScaling.set(a);
	}
	
	public float getChanceScaling() {
		return ChanceScaling.get();
	}

	
    private FloatProperty Speed;

	public void setSpeed(float a) {
		Speed.set(a);
	}
	
	public float getSpeed() {
		return Speed.get();
	}

	
    private FloatProperty SpeedMin;

	public void setSpeedMin(float a) {
		SpeedMin.set(a);
	}
	
	public float getSpeedMin() {
		return SpeedMin.get();
	}

	
    private FloatProperty SpeedMax;

	public void setSpeedMax(float a) {
		SpeedMax.set(a);
	}
	
	public float getSpeedMax() {
		return SpeedMax.get();
	}

	
    private FloatProperty Range;

	public void setRange(float a) {
		Range.set(a);
	}
	
	public float getRange() {
		return Range.get();
	}

	
    private FloatProperty RangeMin;

	public void setRangeMin(float a) {
		RangeMin.set(a);
	}
	
	public float getRangeMin() {
		return RangeMin.get();
	}

	
    private FloatProperty RangeMax;

	public void setRangeMax(float a) {
		RangeMax.set(a);
	}
	
	public float getRangeMax() {
		return RangeMax.get();
	}

	
    private FloatProperty FlipLimit;

	public void setFlipLimit(float a) {
		FlipLimit.set(a);
	}
	
	public float getFlipLimit() {
		return FlipLimit.get();
	}

	
    private FloatProperty TopOnlyChance;

	public void setTopOnlyChance(float a) {
		TopOnlyChance.set(a);
	}
	
	public float getTopOnlyChance() {
		return TopOnlyChance.get();
	}

	
    private FloatProperty EyesClosedMin;

	public void setEyesClosedMin(float a) {
		EyesClosedMin.set(a);
	}
	
	public float getEyesClosedMin() {
		return EyesClosedMin.get();
	}

	
    private FloatProperty EyesOpenTime;

	public void setEyesOpenTime(float a) {
		EyesOpenTime.set(a);
	}
	
	public float getEyesOpenTime() {
		return EyesOpenTime.get();
	}

	
    private FloatProperty EyesClosedTime;

	public void setEyesClosedTime(float a) {
		EyesClosedTime.set(a);
	}
	
	public float getEyesClosedTime() {
		return EyesClosedTime.get();
	}

	
    private FloatProperty LipMorphMax;

	public void setLipMorphMax(float a) {
		LipMorphMax.set(a);
	}
	
	public float getLipMorphMax() {
		return LipMorphMax.get();
	}

	
    private FloatProperty MouthOpenMax;

	public void setMouthOpenMax(float a) {
		MouthOpenMax.set(a);
	}
	
	public float getMouthOpenMax() {
		return MouthOpenMax.get();
	}

	
    private FloatProperty MorphDuration;

	public void setMorphDuration(float a) {
		MorphDuration.set(a);
	}
	
	public float getMorphDuration() {
		return MorphDuration.get();
	}

	
    private FloatProperty HoldSpringPos;

	public void setHoldSpringPos(float a) {
		HoldSpringPos.set(a);
	}
	
	public float getHoldSpringPos() {
		return HoldSpringPos.get();
	}

	
    private FloatProperty HoldSpringRot;

	public void setHoldSpringRot(float a) {
		HoldSpringRot.set(a);
	}
	
	public float getHoldSpringRot() {
		return HoldSpringRot.get();
	}

}

}