using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using UnityEngine.XR;
using UnityEngine.Windows.Speech;

using SimpleJSON;

using MVR.FileManagementSecure;

namespace Amaimon {




    ///////////////////////////////////////////////////
    // Silver HJ
    ///////////////////////////////////////////////////
public class ClockwiseSilverHJPlugin : APlugin {
    public static string LEFT_HAND = "Left";
    public static string RIGHT_HAND = "Right";
    public static string BOTH_HANDS = "Both";


    public ClockwiseSilverHJPlugin(AActor actor) : base(actor, "ClockwiseSilver.HJ") { }
    override public void init() {
        isActive = new BoolProperty(this,"isActive");
        StopHJ = new ActionProperty(this,"Stop HJ");
        Atom = new StringChooserProperty(this,"Atom");
        handedness = new StringChooserProperty(this,"handedness");
        ejEnabled = new BoolProperty(this,"ejEnabled");
        EJWait = new FloatProperty(this,"EJ Wait");
        EJDuration = new FloatProperty(this,"EJ Duration");
        HandSideSide = new FloatProperty(this,"Hand Side/Side");
        HandFwdBkwd = new FloatProperty(this,"Hand Fwd/Bkwd");
        HandShiftUpDown = new FloatProperty(this,"Hand Shift Up/Down");
        HandAngleX = new FloatProperty(this,"Hand Angle X");
        HandAngleY = new FloatProperty(this,"Hand Angle Y");
        HandAngleZ = new FloatProperty(this,"Hand Angle Z");
        HandCloseMax = new FloatProperty(this,"Hand Close Max");
        ThumbOutMax = new FloatProperty(this,"Thumb Out Max");
        GripVariation = new FloatProperty(this,"Grip Variation");
        Hand2SideSide = new FloatProperty(this,"Hand2 Side/Side");
        Hand2ShiftFwdBkwd = new FloatProperty(this,"Hand2 Shift Fwd/Bkwd");
        Hand2ShiftUpDown = new FloatProperty(this,"Hand2 Shift Up/Down");
        HoldSpringPos = new FloatProperty(this,"Hold Spring Pos");
        HoldSpringRot = new FloatProperty(this,"Hold Spring Rot");
        RandomTime = new FloatProperty(this,"Random Time");
        OverallSpeed = new FloatProperty(this,"Overall Speed");
        OverallRange = new FloatProperty(this,"Overall Range");
        AudioVolume = new FloatProperty(this,"Audio Volume");
        RotationSpeed = new FloatProperty(this,"Rotation Speed");
        Speed = new FloatProperty(this,"Speed");
        SpeedMin = new FloatProperty(this,"Speed Min");
        SpeedMax = new FloatProperty(this,"Speed Max");
        Range = new FloatProperty(this,"Range");
        RangeMin = new FloatProperty(this,"Range Min");
        RangeMax = new FloatProperty(this,"Range Max");
        FlipLimit = new FloatProperty(this,"Flip Limit");
        TrackingSpeed = new FloatProperty(this,"Tracking Speed");
        TopOnlyChance = new FloatProperty(this,"Top Only Chance");
        ZStrokeMin = new FloatProperty(this,"Z Stroke Min");
        ZStrokeMax = new FloatProperty(this,"Z Stroke Max");
        baseUpJSON = new BoolProperty(this,"baseUpJSON");
        frontBackOutput = new FloatProperty(this,"frontBackOutput");
    }
	
    private BoolProperty isActive;

	public void setActive(bool a) {
		isActive.set(a);
	}
	
	public bool getActive() {
		return isActive.get();
	}

	
    public ActionProperty StopHJ;

	
    private StringChooserProperty Atom;

	public void setTarget(AActor a, string h) {
		Atom.set(a.person.name);
        handedness.set(h);
	}
	
	public string getAtom() {
		return Atom.get();
	}

	
    private StringChooserProperty handedness;

	public void sethandedness(string a) {
		handedness.set(a);
	}
	
	public string gethandedness() {
		return handedness.get();
	}

	
    private BoolProperty ejEnabled;

	public void setejEnabled(bool a) {
		ejEnabled.set(a);
	}
	
	public bool getejEnabled() {
		return ejEnabled.get();
	}

	
    private FloatProperty EJWait;

	public void setEJWait(float a) {
		EJWait.set(a);
	}
	
	public float getEJWait() {
		return EJWait.get();
	}

	
    private FloatProperty EJDuration;

	public void setEJDuration(float a) {
		EJDuration.set(a);
	}
	
	public float getEJDuration() {
		return EJDuration.get();
	}

	
    private FloatProperty HandSideSide;

	public void setHandSideSide(float a) {
		HandSideSide.set(a);
	}
	
	public float getHandSideSide() {
		return HandSideSide.get();
	}

	
    private FloatProperty HandFwdBkwd;

	public void setHandFwdBkwd(float a) {
		HandFwdBkwd.set(a);
	}
	
	public float getHandFwdBkwd() {
		return HandFwdBkwd.get();
	}

	
    private FloatProperty HandShiftUpDown;

	public void setHandShiftUpDown(float a) {
		HandShiftUpDown.set(a);
	}
	
	public float getHandShiftUpDown() {
		return HandShiftUpDown.get();
	}

	
    private FloatProperty HandAngleX;

	public void setHandAngleX(float a) {
		HandAngleX.set(a);
	}
	
	public float getHandAngleX() {
		return HandAngleX.get();
	}

	
    private FloatProperty HandAngleY;

	public void setHandAngleY(float a) {
		HandAngleY.set(a);
	}
	
	public float getHandAngleY() {
		return HandAngleY.get();
	}

	
    private FloatProperty HandAngleZ;

	public void setHandAngleZ(float a) {
		HandAngleZ.set(a);
	}
	
	public float getHandAngleZ() {
		return HandAngleZ.get();
	}

	
    private FloatProperty HandCloseMax;

	public void setHandCloseMax(float a) {
		HandCloseMax.set(a);
	}
	
	public float getHandCloseMax() {
		return HandCloseMax.get();
	}

	
    private FloatProperty ThumbOutMax;

	public void setThumbOutMax(float a) {
		ThumbOutMax.set(a);
	}
	
	public float getThumbOutMax() {
		return ThumbOutMax.get();
	}

	
    private FloatProperty GripVariation;

	public void setGripVariation(float a) {
		GripVariation.set(a);
	}
	
	public float getGripVariation() {
		return GripVariation.get();
	}

	
    private FloatProperty Hand2SideSide;

	public void setHand2SideSide(float a) {
		Hand2SideSide.set(a);
	}
	
	public float getHand2SideSide() {
		return Hand2SideSide.get();
	}

	
    private FloatProperty Hand2ShiftFwdBkwd;

	public void setHand2ShiftFwdBkwd(float a) {
		Hand2ShiftFwdBkwd.set(a);
	}
	
	public float getHand2ShiftFwdBkwd() {
		return Hand2ShiftFwdBkwd.get();
	}

	
    private FloatProperty Hand2ShiftUpDown;

	public void setHand2ShiftUpDown(float a) {
		Hand2ShiftUpDown.set(a);
	}
	
	public float getHand2ShiftUpDown() {
		return Hand2ShiftUpDown.get();
	}

	
    private FloatProperty HoldSpringPos;

	public void setHoldSpringPos(float a) {
		HoldSpringPos.set(a);
	}
	
	public float getHoldSpringPos() {
		return HoldSpringPos.get();
	}

	
    private FloatProperty HoldSpringRot;

	public void setHoldSpringRot(float a) {
		HoldSpringRot.set(a);
	}
	
	public float getHoldSpringRot() {
		return HoldSpringRot.get();
	}

	
    private FloatProperty RandomTime;

	public void setRandomTime(float a) {
		RandomTime.set(a);
	}
	
	public float getRandomTime() {
		return RandomTime.get();
	}

	
    private FloatProperty OverallSpeed;

	public void setOverallSpeed(float a) {
		OverallSpeed.set(a);
	}
	
	public float getOverallSpeed() {
		return OverallSpeed.get();
	}

	
    private FloatProperty OverallRange;

	public void setOverallRange(float a) {
		OverallRange.set(a);
	}
	
	public float getOverallRange() {
		return OverallRange.get();
	}

	
    private FloatProperty AudioVolume;

	public void setAudioVolume(float a) {
		AudioVolume.set(a);
	}
	
	public float getAudioVolume() {
		return AudioVolume.get();
	}

	
    private FloatProperty RotationSpeed;

	public void setRotationSpeed(float a) {
		RotationSpeed.set(a);
	}
	
	public float getRotationSpeed() {
		return RotationSpeed.get();
	}

	
    private FloatProperty Speed;

	public void setSpeed(float a) {
		Speed.set(a);
	}
	
	public float getSpeed() {
		return Speed.get();
	}

	
    private FloatProperty SpeedMin;

	public void setSpeedMin(float a) {
		SpeedMin.set(a);
	}
	
	public float getSpeedMin() {
		return SpeedMin.get();
	}

	
    private FloatProperty SpeedMax;

	public void setSpeedMax(float a) {
		SpeedMax.set(a);
	}
	
	public float getSpeedMax() {
		return SpeedMax.get();
	}

	
    private FloatProperty Range;

	public void setRange(float a) {
		Range.set(a);
	}
	
	public float getRange() {
		return Range.get();
	}

	
    private FloatProperty RangeMin;

	public void setRangeMin(float a) {
		RangeMin.set(a);
	}
	
	public float getRangeMin() {
		return RangeMin.get();
	}

	
    private FloatProperty RangeMax;

	public void setRangeMax(float a) {
		RangeMax.set(a);
	}
	
	public float getRangeMax() {
		return RangeMax.get();
	}

	
    private FloatProperty FlipLimit;

	public void setFlipLimit(float a) {
		FlipLimit.set(a);
	}
	
	public float getFlipLimit() {
		return FlipLimit.get();
	}

	
    private FloatProperty TrackingSpeed;

	public void setTrackingSpeed(float a) {
		TrackingSpeed.set(a);
	}
	
	public float getTrackingSpeed() {
		return TrackingSpeed.get();
	}

	
    private FloatProperty TopOnlyChance;

	public void setTopOnlyChance(float a) {
		TopOnlyChance.set(a);
	}
	
	public float getTopOnlyChance() {
		return TopOnlyChance.get();
	}

	
    private FloatProperty ZStrokeMin;

	public void setZStrokeMin(float a) {
		ZStrokeMin.set(a);
	}
	
	public float getZStrokeMin() {
		return ZStrokeMin.get();
	}

	
    private FloatProperty ZStrokeMax;

	public void setZStrokeMax(float a) {
		ZStrokeMax.set(a);
	}
	
	public float getZStrokeMax() {
		return ZStrokeMax.get();
	}

	
    private BoolProperty baseUpJSON;

	public void setbaseUpJSON(bool a) {
		baseUpJSON.set(a);
	}
	
	public bool getbaseUpJSON() {
		return baseUpJSON.get();
	}

	
    private FloatProperty frontBackOutput;

	public void setfrontBackOutput(float a) {
		frontBackOutput.set(a);
	}
	
	public float getfrontBackOutput() {
		return frontBackOutput.get();
	}



}
}